Attribute VB_Name = "Module1"
'This module holds the RDSS and RDWS parsers, the HTTP, FTP parsers
Public srvRoot As String   'Server's root
Public an_ver As String 'The AdvancedNET version
Public to_Send As String
Public fl_Def As String
Public bu_Da As String
Public bytesSnt As Long
Public bytesRem As Long
Public Function convState(theState As Integer, thePort As Long) As String
If theState = 0 Then
convState = "Idle"
End If
If theState = 8 Then
convState = "Waiting to Close"
End If
If theState = 7 Then
convState = "Connected"
End If
If theState = 6 Then
convState = "Connecting..."
End If
If theState = 3 Then
convState = "Connection Pending"
End If
If theState = 9 Then
convState = "ERROR!"
End If
If theState = 5 Then
convState = "Host Resolved"
End If
If theState = 2 Then
convState = "Listening on port" + Str(thePort)
End If
If theState = 1 Then
convState = "Open"
End If
If theState = 4 Then
convState = "Resolving Host..."
End If
End Function

Public Sub parse_Script(scrData As String, requestID As Long, Connects As Long, acceptorID As Integer)
'Parse Globals
'You can find globals in the text file: "red dragon server script (rdss).txt"
scrData = Replace(scrData, "%MyIP", serWkspc.send(0).LocalIP)
scrData = Replace(scrData, "%MyPort", Str(serWkspc.send(0).LocalPort))
scrData = Replace(scrData, "%MyName", serWkspc.send(0).LocalHostName)
scrData = Replace(scrData, "%TheirIP", serWkspc.acceptor(acceptorID).RemoteHostIP)
scrData = Replace(scrData, "%TheirName", serWkspc.acceptor(acceptorID).RemoteHost)
scrData = Replace(scrData, "%RequestID", Str(requestID))
scrData = Replace(scrData, "%MyStateList", Str(serWkspc.send(0).State))
scrData = Replace(scrData, "%MyStateAccp", Str(serWkspc.acceptor(acceptorID).State))
scrData = Replace(scrData, "%Root", srvRoot)
scrData = Replace(scrData, "%Version", serv_Name)
End Sub
Public Sub parse_HTTP(httpData As String)
On Error Resume Next
'Parse HTTP commands
'Should be HTTP/1.1 compatible.
If LCase(Left(Trim(httpData), 3)) = "get" Then
httpGET httpData
End If
End Sub

Public Function FileExists(FileName As String) As Boolean
    FileExists = Not (Dir(FileName) = "")
End Function
Public Function parse_Viper(Viper As String) As String
'This will parse a viper script
'This is Viper 0.01. It only supports file handling
'custom telnet commands and output html
'Also supports variable setting, string manip. and maths
'Look for commands (prefixed _)
'Will return an output html string
Dim Where As Long
Dim params(0 To 4) As String
Dim paramSt As Long
Dim paramEd As Long
Dim temp1 As String
Dim errs As String 'This is where errors go
'Command: _FWrite(string FileName,string Data)
Where = 1
paramEd = 1
Do Until Where < 1
Where = InStr(paramEd, Viper, "_FWrite")
If Where > 0 Then
    paramSt = InStr(Where + 7, Viper, """")
    paramEd = InStr(paramSt + 1, Viper, """")
    params(0) = Mid(Viper, paramSt + 1, paramEd - paramSt - 1) 'We got us our first param!
    params(0) = Replace(params(0), "/", "\")
    paramSt = InStr(paramEd + 1, Viper, """")
    paramEd = InStr(paramSt + 1, Viper, """")
    params(1) = Mid(Viper, paramSt + 1, paramEd - paramSt - 1) 'Second Parameter
    Open srvRoot + params(0) For Output As #1 '  Print #1, params(1)
   Close #1
 End If
Loop
Where = 1
paramEd = 1
'Command: _FOpen(string FileName,new variable Data)
Do Until Where < 1
Where = InStr(paramEd, Viper, "_FOpen")
If Where > 0 Then
    paramSt = InStr(Where + 6, Viper, """")
    paramEd = InStr(paramSt + 1, Viper, """")
    params(0) = Mid(Viper, paramSt + 1, paramEd - paramSt - 1) 'We got us our first param!
    params(0) = Replace(params(0), "/", "\")
    paramSt = InStr(paramEd + 1, Viper, "_")
    paramEd = InStr(paramSt + 1, Viper, "_")
    params(1) = Mid(Viper, paramSt, paramEd - paramSt + 1) 'Second Parameter
    Open srvRoot + params(0) For Input As #1
    temp1 = Input$(LOF(1), 1)
    Close #1
    Viper = Replace(Viper, params(1), temp1) 'This will get any occurences
    'of the newly made var, and replace it with the file data
End If
Loop
End Function
